stages:
  - build
  - deploy

.only-default: &only-default
  only:
    - merge_requests
    - tags
    - develop
    - master

docker-build:
  stage: build
  <<: *only-default
  services: [ 'docker:19.03.1-dind' ]
  variables:
    DOCKER_TLS_CERTDIR: '/certs'
  image: 'docker:19.03.1'
  script:
    - docker info
    - docker build -t jarvis-network/burner-wallet .

build:
  stage: build
  <<: *only-default
  image: 'node:lts-alpine'
  before_script:
    - apk add git python3 make g++
  cache:
    paths:
      - node_modules/
  script:
    - yarn install
    - yarn build
    - git diff-index --exit-code HEAD
  artifacts:
    paths:
      - apps/jarvis-wallet/build/

.deploy-default: &deploy-default
  image: 'node:lts-alpine'
  stage: deploy
  needs:
    - job: build
      artifacts: true
  before_script:
    - yarn global add netlify-cli

deploy-preview-to-netlify:
  <<: *deploy-default
  only:
    - merge_requests
  script:
    - netlify deploy --dir ./apps/jarvis-wallet/build/

deploy-develop-to-netlify:
  <<: *deploy-default
  only:
    - develop
  script:
    - netlify deploy --prod --dir ./apps/jarvis-wallet/build/
